/**
 */
package tools.descartes.dni.dnimm3.provider;


import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

import tools.descartes.dni.dnimm3.DNIFactory;
import tools.descartes.dni.dnimm3.DNIPackage;
import tools.descartes.dni.dnimm3.PerformanceNetworkInterface;

/**
 * This is the item provider adapter for a {@link tools.descartes.dni.dnimm3.PerformanceNetworkInterface} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class PerformanceNetworkInterfaceItemProvider 
	extends ItemProviderAdapter
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PerformanceNetworkInterfaceItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addIsUpPropertyDescriptor(object);
			addMTUPropertyDescriptor(object);
			addEntityTypePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Is Up feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addIsUpPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_PerformanceNetworkInterface_isUp_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_PerformanceNetworkInterface_isUp_feature", "_UI_PerformanceNetworkInterface_type"),
				 DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__IS_UP,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.BOOLEAN_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the MTU feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addMTUPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_PerformanceNetworkInterface_MTU_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_PerformanceNetworkInterface_MTU_feature", "_UI_PerformanceNetworkInterface_type"),
				 DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__MTU,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.INTEGRAL_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Entity Type feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addEntityTypePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_PerformanceNetworkInterface_entityType_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_PerformanceNetworkInterface_entityType_feature", "_UI_PerformanceNetworkInterface_type"),
				 DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__ENTITY_TYPE,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__PACKET_PROCESSING_TIME);
			childrenFeatures.add(DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__INTERFACE_THROUGHPUT);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns PerformanceNetworkInterface.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/PerformanceNetworkInterface"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		PerformanceNetworkInterface performanceNetworkInterface = (PerformanceNetworkInterface)object;
		return getString("_UI_PerformanceNetworkInterface_type") + " " + performanceNetworkInterface.isIsUp();
	}
	

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(PerformanceNetworkInterface.class)) {
			case DNIPackage.PERFORMANCE_NETWORK_INTERFACE__IS_UP:
			case DNIPackage.PERFORMANCE_NETWORK_INTERFACE__MTU:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case DNIPackage.PERFORMANCE_NETWORK_INTERFACE__PACKET_PROCESSING_TIME:
			case DNIPackage.PERFORMANCE_NETWORK_INTERFACE__INTERFACE_THROUGHPUT:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__PACKET_PROCESSING_TIME,
				 DNIFactory.eINSTANCE.createConstantDoubleVariable()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__PACKET_PROCESSING_TIME,
				 DNIFactory.eINSTANCE.createConstantLongVariable()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__PACKET_PROCESSING_TIME,
				 DNIFactory.eINSTANCE.createRandomVariable()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__PACKET_PROCESSING_TIME,
				 DNIFactory.eINSTANCE.createDiscreteFunction()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__PACKET_PROCESSING_TIME,
				 DNIFactory.eINSTANCE.createExponentialFunction()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__INTERFACE_THROUGHPUT,
				 DNIFactory.eINSTANCE.createConstantDoubleVariable()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__INTERFACE_THROUGHPUT,
				 DNIFactory.eINSTANCE.createConstantLongVariable()));

		newChildDescriptors.add
			(createChildParameter
				(DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__INTERFACE_THROUGHPUT,
				 DNIFactory.eINSTANCE.createRandomVariable()));
	}

	/**
	 * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify =
			childFeature == DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__PACKET_PROCESSING_TIME ||
			childFeature == DNIPackage.Literals.PERFORMANCE_NETWORK_INTERFACE__INTERFACE_THROUGHPUT;

		if (qualify) {
			return getString
				("_UI_CreateChild_text2",
				 new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

	/**
	 * Return the resource locator for this item provider's resources.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		return Dnimm3EditPlugin.INSTANCE;
	}

}
