package tools.descartes.dni.dnimm3.tools;

import java.io.File;
import java.io.IOException;
import java.util.Collections;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;

import tools.descartes.dni.dnimm3.DNIPackage;
import tools.descartes.dni.dnimm3.NetworkInfrastructure;
import tools.descartes.dni.dnimm3.impl.NetworkInfrastructureImpl;

public class Parser {

	public static NetworkInfrastructureImpl convertFileToModel(File file) {
		ResourceSet resourceSet = new ResourceSetImpl();
		resourceSet.getResourceFactoryRegistry().getExtensionToFactoryMap()
				.put(Resource.Factory.Registry.DEFAULT_EXTENSION, new XMIResourceFactoryImpl());
		resourceSet.getPackageRegistry().put(DNIPackage.eNS_URI, DNIPackage.eINSTANCE);
		Resource resource = resourceSet.getResource(URI.createFileURI(file.getPath()), true);
		return (NetworkInfrastructureImpl) resource.getContents().get(0);
	}

	public static File convertModelToFile(NetworkInfrastructure networkInfrastructure) throws IOException {
		File output = File.createTempFile("dni-", ".dni");
		output.deleteOnExit();
		ResourceSet resourceSet = new ResourceSetImpl();
		resourceSet.getResourceFactoryRegistry().getExtensionToFactoryMap()
				.put(Resource.Factory.Registry.DEFAULT_EXTENSION, new XMIResourceFactoryImpl());
		resourceSet.getPackageRegistry().put(DNIPackage.eNS_URI, DNIPackage.eINSTANCE);
		Resource resource = resourceSet.createResource(URI.createURI(output.toURI().getPath()));
		resource.getContents().add(networkInfrastructure);
		resource.save(Collections.EMPTY_MAP);
		return output;
	}

}
