package tools.descartes.dni.dnimm3.tools;

import java.io.File;
import java.io.IOException;

import org.junit.Assert;
import org.junit.Test;

import tools.descartes.dni.dnimm3.NetworkInfrastructure;
import tools.descartes.dni.dnimm3.impl.DNIFactoryImpl;
import tools.descartes.dni.dnimm3.impl.NetworkInfrastructureImpl;

public class ParserTest {

	@Test
	public void shouldConvertFileToModel() {
		File file = new File("src/test/resources/scenario0A.dni");
		NetworkInfrastructureImpl networkInfrastructure = Parser.convertFileToModel(file);
		Assert.assertEquals(6, networkInfrastructure.getStructure().getNodes().size());
	}

	@Test
	public void shouldConvertModelToFile() throws IOException {
		DNIFactoryImpl factory = new DNIFactoryImpl();
		NetworkInfrastructure model = factory.createNetworkInfrastructure();
		File file = Parser.convertModelToFile(model);
		Assert.assertTrue(file.length() > 100);
	}

}
